package cn.com.tenlion.materialstore.service.materialvideo;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.materialstore.pojo.dtos.materialvideo.MaterialVideoDTO;
import cn.com.tenlion.materialstore.pojo.vos.materialvideo.MaterialVideoVO;
import cn.com.tenlion.materialstore.pojo.bos.materialvideo.MaterialVideoBO;
import cn.com.tenlion.materialstore.pojo.pos.materialvideo.MaterialVideoPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IMaterialVideoService
 * @Description: 视频素材
 * @Author: CodeFactory
 * @Date: 2021-05-28 11:07:46
 * @Version: 3.0
 **/
public interface IMaterialVideoService {

    /**
     * 新增视频素材
     *
     * @param materialVideoVO
     * @return
     */
    void save(MaterialVideoVO materialVideoVO);

    /**
     * 新增视频素材
     *
     * @param token
     * @param materialVideoVO
     * @return
     */
    void save(String token, MaterialVideoVO materialVideoVO);

    /**
     * 新增视频素材
     *
     * @param materialVideoVO
     * @return materialVideoId
     */
    String saveReturnId(MaterialVideoVO materialVideoVO);

    /**
     * 新增视频素材
     *
     * @param token
     * @param materialVideoVO
     * @return materialVideoId
     */
    String saveReturnId(String token, MaterialVideoVO materialVideoVO);

    /**
     * 删除视频素材
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除视频素材
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除视频素材（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改视频素材
     *
     * @param materialVideoId
     * @param materialVideoVO
     * @return
     */
    void update(String materialVideoId, MaterialVideoVO materialVideoVO);

    /**
     * 修改视频素材
     *
     * @param token
     * @param materialVideoId
     * @param materialVideoVO
     * @return
     */
    void update(String token, String materialVideoId, MaterialVideoVO materialVideoVO);

    /**
     * 视频素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialVideoDTO get(Map<String, Object> params);

    /**
     * 视频素材详情
     *
     * @param materialVideoId
     * @return
     */
    MaterialVideoDTO get(String materialVideoId);

    /**
     * 视频素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialVideoBO getBO(Map<String, Object> params);

    /**
     * 视频素材详情
     *
     * @param materialVideoId
     * @return
     */
    MaterialVideoBO getBO(String materialVideoId);

    /**
     * 视频素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialVideoPO getPO(Map<String, Object> params);

    /**
     * 视频素材详情
     *
     * @param materialVideoId
     * @return
     */
    MaterialVideoPO getPO(String materialVideoId);

    /**
     * 视频素材列表
     *
     * @param params
     * @return
     */
    List<MaterialVideoDTO> list(Map<String, Object> params);

    /**
     * 视频素材列表
     *
     * @param params
     * @return
     */
    List<MaterialVideoBO> listBO(Map<String, Object> params);

    /**
     * 视频素材列表
     *
     * @param params
     * @return
     */
    List<MaterialVideoPO> listPO(Map<String, Object> params);

    /**
     * 视频素材分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<MaterialVideoDTO>> listPage(ListPage page);

    /**
     * 视频素材统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    List<MaterialVideoDTO> getByMaterialId(String materialId);

    void removeByMaterialId(String materialId);

    void updateCheck(String id);
}